/*
 * Copyright (C) 2019 iopsys Software Solutions AB
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2.1
 * as published by the Free Software Foundation
 *
 *		Author: Amin Ben Ramdhane <amin.benramdhane@pivasoftware.com>
 */

#ifndef _DNS_H
#define _DNS_H

#include "libbbfdm-api/dmcommon.h"
#include <libbbfdm_api.h>
#include <json-c/json.h>


#define HOSTS_LIST_SIZE			1024
#define HOST_STR_SIZE			32

// for cppcheck warnings
#define JSON_NULL_AND_RETURN_MSG(X, CTX, MSG, RV) \
        if (X == NULL) { \
		bbfdm_set_fault_message(CTX, MSG); \
                return RV; \
        }

struct srv_info
{
	char *instance_name;
	char *application_protocol;
	bool transport_protocol_flag;
};

enum enum_transport_protocol
{
        TRANSPORT_TCP,
        TRANSPORT_UDP
};

extern DMOBJ tDNSObj[];
extern DMLEAF tDNSParams[];
extern DMLEAF tDNSClientParams[];
extern DMOBJ tDNSClientObj[];
extern DMLEAF tDNSClientServerParams[];
extern DMLEAF tDNSRelayParams[];
extern DMOBJ tDNSRelayObj[];
extern DMLEAF tDNSRelayForwardingParams[];
extern DMOBJ tDNSDiagnosticsObj[];
extern DMLEAF tDNSDiagnosticsParams[];
extern DMLEAF tDNSDiagnosticsNSLookupDiagnosticsParams[];
extern DMOBJ tDNSDiagnosticsNSLookupDiagnosticsObj[];
extern DMLEAF tDNSDiagnosticsNSLookupDiagnosticsResultParams[];
extern DMLEAF tDNSSDParams[];
extern DMOBJ tDNSSDObj[];
extern DMLEAF tDNSSDServiceParams[];
extern DMOBJ tDNSSDServiceObj[];
extern DMLEAF tDNSSDServiceTextRecordParams[];

char *get_dnsmasq_section_name(void);
#endif
